ARCHITECTURE singleCounter OF ultrasoundRanger IS

  signal timeCounter: unsigned(counterBitNb-1 downto 0);
  signal pulseDelayed, pulseEnd: std_ulogic;

BEGIN
  ------------------------------------------------------------------------------
                                                  -- generate a measurement ramp
  periodCounter: process(reset, clock)
  begin
    if reset = '1' then
      timeCounter <= (others => '0');
    elsif rising_edge(clock) then
      timeCounter <= timeCounter + 1;
    end if;
  end process periodCounter;

  startmeasure <= '1' when timeCounter < 100
    else '0';

  ------------------------------------------------------------------------------
                                                            -- find end of pulse
  delayPulse: process(reset, clock)
  begin
    if reset = '1' then
      pulseDelayed <= '0';
    elsif rising_edge(clock) then
      pulseDelayed <= distancePulse;
    end if;
  end process delayPulse;

  pulseEnd <= '1' when (distancePulse = '0') and (pulseDelayed = '1')
    else '0';

  ------------------------------------------------------------------------------
                                                               -- store distance
  storeDistance: process(reset, clock)
  begin
    if reset = '1' then
      distance <= (others => '0');
    elsif rising_edge(clock) then
      if pulseEnd = '1' then
        distance <= resize(timeCounter, distance'length);
      end if;
    end if;
  end process storeDistance;

END ARCHITECTURE singleCounter;
