-- VHDL Entity Board.FPGA_stepperMotorController.symbol
--
-- Created:
--          by - guo.UNKNOWN (WEA20309)
--          at - 10:09:41 28.08.2014
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2009.2 (Build 10)
--
LIBRARY ieee;
   USE ieee.std_logic_1164.all;
   USE ieee.numeric_std.all;

ENTITY FPGA_stepperMotorController IS
   GENERIC( 
      ioBitNb   : positive := 20;
      jtagBitNb : positive := 3
   );
   PORT( 
      clock   : IN     std_ulogic;
      reset_n : IN     std_uLogic;
      sCl     : IN     std_logic;
      I_O     : INOUT  std_logic_vector (1 TO ioBitNb);
      jtagIo  : INOUT  std_ulogic_vector (1 TO jtagBitNb);
      sDa     : INOUT  std_logic
   );

-- Declarations

END FPGA_stepperMotorController ;





-- VHDL Entity StepperMotor.stepperMotorController.symbol
--
-- Created:
--          by - guo.UNKNOWN (WEA20309)
--          at - 10:09:41 28.08.2014
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2009.2 (Build 10)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
  USE ieee.numeric_std.all;

ENTITY stepperMotorController IS
   GENERIC( 
      i2cBitNb               : positive := 10;
      prescalerBitNb         : positive := 16;
      testPrescalerBitNb     : positive := 10;
      dividerBitNb           : positive := 8;
      angleBitNb             : positive := 4;
      hwOrientationBitNb     : positive := 3;
      kartBaseAddress        : positive := 16#26#;
      stepperBaseAddress     : natural  := 0;
      orientationBaseAddress : natural  := 8;
      testBitNb              : positive := 8
   );
   PORT( 
      clock      : IN     std_ulogic;
      reset      : IN     std_ulogic;
      sClIn      : IN     std_uLogic;
      sDaIn      : IN     std_uLogic;
      stepperEnd : IN     std_ulogic;
      testMode   : IN     std_ulogic;
      coil1      : OUT    std_ulogic;
      coil2      : OUT    std_ulogic;
      coil3      : OUT    std_ulogic;
      coil4      : OUT    std_ulogic;
      sDaOut     : OUT    std_uLogic;
      testOut    : OUT    std_ulogic_vector (1 TO testBitNb)
   );

-- Declarations

END stepperMotorController ;





-- VHDL Entity StepperMotor.angleControl.symbol
--
-- Created:
--          by - guo.UNKNOWN (WEA20309)
--          at - 10:09:41 28.08.2014
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2009.2 (Build 10)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
  USE ieee.numeric_std.all;

ENTITY angleControl IS
   GENERIC( 
      angleNbBits : positive := 8
   );
   PORT( 
      clock      : IN     std_uLogic;
      clockwise  : IN     std_uLogic;
      enStep     : IN     std_uLogic;
      reset      : IN     std_uLogic;
      restart    : IN     std_ulogic;
      sensorLeft : IN     std_uLogic;
      stepperEnd : IN     std_uLogic;
      target     : IN     unsigned (16-1 DOWNTO 0);  -- (angleNbBits-1:0)
      actual     : OUT    unsigned (16-1 DOWNTO 0);  -- (angleNbBits-1:0)
      coil1      : OUT    std_ulogic;
      coil2      : OUT    std_uLogic;
      coil3      : OUT    std_uLogic;
      coil4      : OUT    std_uLogic;
      reached    : OUT    std_ulogic
   );

-- Declarations

END angleControl ;





-- VHDL Entity StepperMotor.stepperCounter.symbol
--
-- Created:
--          by - guo.UNKNOWN (WEA20309)
--          at - 10:22:13 28.08.2014
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2009.2 (Build 10)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
  USE ieee.numeric_std.all;

ENTITY stepperCounter IS
   GENERIC( 
      angleNbBits : positive := 16
   );
   PORT( 
      clock         : IN     std_ulogic;
      enCoils       : IN     std_ulogic;
      incCount      : IN     std_ulogic;
      reset         : IN     std_ulogic;
      step          : IN     std_ulogic;
      stepperEnd    : IN     std_ulogic;
      motorPosition : OUT    unsigned (angleNbBits-1 DOWNTO 0)
   );

-- Declarations

END stepperCounter ;





ARCHITECTURE RTL OF stepperCounter IS

  signal sMotorPosition: unsigned(motorPosition'range);

BEGIN

  count: process(reset, clock)
  begin
    if reset = '1' then
      sMotorPosition <= (others => '0');
    elsif rising_edge(clock) then
      if stepperEnd = '1' then
        sMotorPosition <= (others => '0');
      elsif (step = '1') and (enCoils = '1') then
        if incCount = '1' then
          sMotorPosition <= sMotorPosition + 1;
        else
          sMotorPosition <= sMotorPosition - 1;
        end if;
      end if;
    end if;
  end process count;

  motorPosition <= sMotorPosition;

END ARCHITECTURE RTL;




LIBRARY ieee;
USE ieee.std_logic_1164.all;

PACKAGE gates IS

--  constant gateDelay: time := 1 ns;
  constant gateDelay: time := 0.1 ns;

END gates;




-- VHDL Entity sequential.DFFE.symbol
--
-- Created:
--          by - francois.UNKNOWN (WE3673)
--          at - 14:35:44 10.08.2012
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2009.2 (Build 10)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
-- LIBRARY gates;
  use work.gates.all;

ENTITY DFFE IS
   GENERIC( 
      delay : time := gateDelay
   );
   PORT( 
      CLK : IN     std_uLogic;
      CLR : IN     std_uLogic;
      D   : IN     std_uLogic;
      E   : IN     std_uLogic;
      Q   : OUT    std_uLogic
   );

-- Declarations

END DFFE ;





ARCHITECTURE sim OF DFFE IS
BEGIN

  process(clk, clr)
  begin
    if clr = '1' then
      q <= '0' after delay;
    elsif rising_edge(clk) then
      if e = '1' then
        q <= d after delay;
      end if;
    end if;
  end process;

END ARCHITECTURE sim;





-- VHDL Entity StepperMotor.angleDifference.symbol
--
-- Created:
--          by - guo.UNKNOWN (WEA20309)
--          at - 10:22:13 28.08.2014
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2009.2 (Build 10)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
  USE ieee.numeric_std.all;

ENTITY angleDifference IS
   GENERIC( 
      angleNbBits : positive := 16
   );
   PORT( 
      actualPosition : IN     unsigned (angleNbBits-1 DOWNTO 0);
      clock          : IN     std_ulogic;
      reset          : IN     std_ulogic;
      restart        : IN     std_ulogic;
      stepperEnd     : IN     std_ulogic;
      targetPosition : IN     unsigned (angleNbBits-1 DOWNTO 0);
      enCoils        : OUT    std_ulogic;
      incAngle       : OUT    std_ulogic;
      reached        : OUT    std_ulogic
   );

-- Declarations

END angleDifference ;





ARCHITECTURE RTL OF angleDifference IS

  signal initDone: std_ulogic;

  signal difference: signed(targetPosition'high+1 downto 0);
  signal reached_int: std_ulogic;

BEGIN

  difference <= signed(resize(targetPosition, difference'length) - actualPosition);

  reached_int <= '1' when abs(difference) <= 1 else '0';
  reached <= reached_int;

--  incAngle <= '0' when (initDone = '0') or (difference < 0) else '1';
  chooseDirection: process(initDone, difference)
  begin
    if initDone = '0' then
      incAngle <= '0';
    else -- initDone = '1'
      if difference >= 0 then
        incAngle <= '1';
      else
        incAngle <= '0';
      end if;
    end if;
  end process chooseDirection;

  enCoils <= '1' when (initDone = '0') or (reached_int = '0') else '0';

  goToZero: process(reset, clock)
  begin
    if reset = '1' then
      initDone <= '0';
    elsif rising_edge(clock) then
      if restart = '1' then
        initDone <= '0';
      elsif stepperEnd = '1' then
        initDone <= '1';
      end if;
    end if;
  end process goToZero;

END ARCHITECTURE RTL;




-- VHDL Entity StepperMotor.coilControl.symbol
--
-- Created:
--          by - guo.UNKNOWN (WEA20309)
--          at - 10:22:13 28.08.2014
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2009.2 (Build 10)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
  USE ieee.numeric_std.all;

ENTITY coilControl IS
   PORT( 
      clock   : IN     std_ulogic;
      dir1to4 : IN     std_ulogic;
      enCoils : IN     std_ulogic;
      reset   : IN     std_ulogic;
      step    : IN     std_ulogic;
      coil1   : OUT    std_ulogic;
      coil2   : OUT    std_uLogic;
      coil3   : OUT    std_uLogic;
      coil4   : OUT    std_uLogic
   );

-- Declarations

END coilControl ;





ARCHITECTURE RTL OF coilControl IS

  signal phaseCounter: unsigned(1 downto 0);

BEGIN

  countPhases: process(reset, clock)
  begin
    if reset = '1' then
      phaseCounter <= (others => '0');
    elsif rising_edge(clock) then
      if (enCoils = '1') and (step = '1') then
        if dir1to4 = '1' then
          phaseCounter <= phaseCounter + 1;
        else
          phaseCounter <= phaseCounter - 1;
        end if;
      end if;
    end if;
  end process countPhases;

  driveCoils: process(enCoils, phaseCounter)
  begin
    coil1 <= '0';
    coil2 <= '0';
    coil3 <= '0';
    coil4 <= '0';
    if enCoils = '1' then
      case to_integer(phaseCounter) is
        when 0 => coil1 <= '1';
        when 1 => coil2 <= '1';
        when 2 => coil3 <= '1';
        when 3 => coil4 <= '1';
        when others => null;
      end case;
    end if; 
  end process driveCoils;

END ARCHITECTURE RTL;




--
-- VHDL Architecture StepperMotor.angleControl.struct
--
-- Created:
--          by - guo.UNKNOWN (WEA20309)
--          at - 10:22:14 28.08.2014
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2009.2 (Build 10)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
  USE ieee.numeric_std.all;
-- LIBRARY gates;
  use work.gates.all;

-- LIBRARY sequential;
-- LIBRARY StepperMotor;

ARCHITECTURE struct OF angleControl IS

   -- Architecture declarations

   -- Internal signal declarations
   SIGNAL dir1to4      : std_ulogic;
   SIGNAL enCoils      : std_ulogic;
   SIGNAL enCoilsSynch : std_ulogic;
   SIGNAL incAngle     : std_ulogic;

   -- Implicit buffer signal declarations
   SIGNAL actual_internal : unsigned (16-1 DOWNTO 0);


   -- Component Declarations
   COMPONENT DFFE
   GENERIC (
      delay : time := gateDelay
   );
   PORT (
      CLK : IN     std_uLogic ;
      CLR : IN     std_uLogic ;
      D   : IN     std_uLogic ;
      E   : IN     std_uLogic ;
      Q   : OUT    std_uLogic 
   );
   END COMPONENT;
   COMPONENT angleDifference
   GENERIC (
      angleNbBits : positive := 16
   );
   PORT (
      actualPosition : IN     unsigned (angleNbBits-1 DOWNTO 0);
      clock          : IN     std_ulogic ;
      reset          : IN     std_ulogic ;
      restart        : IN     std_ulogic ;
      stepperEnd     : IN     std_ulogic ;
      targetPosition : IN     unsigned (angleNbBits-1 DOWNTO 0);
      enCoils        : OUT    std_ulogic ;
      incAngle       : OUT    std_ulogic ;
      reached        : OUT    std_ulogic 
   );
   END COMPONENT;
   COMPONENT coilControl
   PORT (
      clock   : IN     std_ulogic ;
      dir1to4 : IN     std_ulogic ;
      enCoils : IN     std_ulogic ;
      reset   : IN     std_ulogic ;
      step    : IN     std_ulogic ;
      coil1   : OUT    std_ulogic ;
      coil2   : OUT    std_uLogic ;
      coil3   : OUT    std_uLogic ;
      coil4   : OUT    std_uLogic 
   );
   END COMPONENT;
   COMPONENT stepperCounter
   GENERIC (
      angleNbBits : positive := 16
   );
   PORT (
      clock         : IN     std_ulogic ;
      enCoils       : IN     std_ulogic ;
      incCount      : IN     std_ulogic ;
      reset         : IN     std_ulogic ;
      step          : IN     std_ulogic ;
      stepperEnd    : IN     std_ulogic ;
      motorPosition : OUT    unsigned (angleNbBits-1 DOWNTO 0)
   );
   END COMPONENT;

   -- Optional embedded configurations
   -- pragma synthesis_off
--    FOR ALL : DFFE USE ENTITY sequential.DFFE;
--    FOR ALL : angleDifference USE ENTITY StepperMotor.angleDifference;
--    FOR ALL : coilControl USE ENTITY StepperMotor.coilControl;
--    FOR ALL : stepperCounter USE ENTITY StepperMotor.stepperCounter;
   -- pragma synthesis_on


BEGIN
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 1 eb1
   dir1to4 <= incAngle xor clockwise xor sensorLeft;


   -- Instance port mappings.
   I_DFFE : DFFE
      GENERIC MAP (
         delay => gateDelay
      )
      PORT MAP (
         CLK => clock,
         CLR => reset,
         D   => enCoils,
         E   => enStep,
         Q   => enCoilsSynch
      );
   I_diff : angleDifference
      GENERIC MAP (
         angleNbBits => angleNbBits
      )
      PORT MAP (
         actualPosition => actual_internal,
         clock          => clock,
         reset          => reset,
         restart        => restart,
         stepperEnd     => stepperEnd,
         targetPosition => target,
         enCoils        => enCoils,
         incAngle       => incAngle,
         reached        => reached
      );
   I_phases : coilControl
      PORT MAP (
         clock   => clock,
         dir1to4 => dir1to4,
         enCoils => enCoilsSynch,
         reset   => reset,
         step    => enStep,
         coil1   => coil1,
         coil2   => coil2,
         coil3   => coil3,
         coil4   => coil4
      );
   I_cnt : stepperCounter
      GENERIC MAP (
         angleNbBits => angleNbBits
      )
      PORT MAP (
         clock         => clock,
         enCoils       => enCoilsSynch,
         incCount      => incAngle,
         reset         => reset,
         step          => enStep,
         stepperEnd    => stepperEnd,
         motorPosition => actual_internal
      );

   -- Implicit buffered output assignments
   actual <= actual_internal;

END struct;




-- VHDL Entity StepperMotor.stepperMotorDivider.symbol
--
-- Created:
--          by - guo.UNKNOWN (WEA20309)
--          at - 10:09:41 28.08.2014
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2009.2 (Build 10)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
  USE ieee.numeric_std.all;

ENTITY stepperMotorDivider IS
   GENERIC( 
      prescalerBitNb     : positive := 8;
      testPrescalerBitNb : positive := 10;
      dividerBitNb       : positive := 16
   );
   PORT( 
      clock    : IN     std_ulogic;
      reset    : IN     std_ulogic;
      pwmEn    : OUT    std_ulogic;
      divider  : IN     unsigned (dividerBitNb-1 DOWNTO 0);
      testMode : IN     std_ulogic
   );

-- Declarations

END stepperMotorDivider ;





ARCHITECTURE RTL OF stepperMotorDivider IS

  signal testPrescalerCounter: unsigned(testPrescalerBitNb-1 downto 0);
  signal testPrescalerDone: std_ulogic;

  signal prescalerCounter: unsigned(prescalerBitNb-1 downto 0);
  signal prescalerDone: std_ulogic;

  signal dividerCounter: unsigned(divider'range);
  signal divideDone: std_ulogic;

BEGIN
  ------------------------------------------------------------------------------
                                                  -- test mode prescaler counter
  testDivide: process(reset, clock)
  begin
    if reset = '1' then
      testPrescalerCounter <= (others => '0');
    elsif rising_edge(clock) then
      testPrescalerCounter <= testPrescalerCounter + 1;
    end if;
  end process testDivide;

  testPrescalerDone <= '1' when testMode = '0'
    else '1' when testPrescalerCounter = 0
    else '0';

  ------------------------------------------------------------------------------
                                                            -- prescaler counter
  prescalerDivide: process(reset, clock)
  begin
    if reset = '1' then
      prescalerCounter <= (others => '0');
    elsif rising_edge(clock) then
      if testPrescalerDone = '1' then
        prescalerCounter <= prescalerCounter + 1;
      end if;
    end if;
  end process prescalerDivide;

  prescalerDone <= testPrescalerDone when prescalerCounter = 0
    else '0';

  ------------------------------------------------------------------------------
                                                            -- presacler counter
  stepDivide: process(reset, clock)
  begin
    if reset = '1' then
      dividerCounter <= (others => '0');
    elsif rising_edge(clock) then
      if prescalerDone = '1' then
        if divideDone = '1' then
          dividerCounter <= (others => '0');
        else
          dividerCounter <= dividerCounter + 1;
        end if;
      end if;
    end if;
  end process stepDivide;

  divideDone <= prescalerDone when dividerCounter+1 >= divider
    else '0';
  pwmEn <= divideDone;

END ARCHITECTURE RTL;




-- VHDL Entity I2C.i2cTransceiver.symbol
--
-- Created:
--          by - francois.UNKNOWN (WE3673)
--          at - 11:18:30 19.05.2014
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2009.2 (Build 10)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
  USE ieee.numeric_std.all;

ENTITY i2cTransceiver IS
   GENERIC( 
      dataBitNb : positive := 10
   );
   PORT( 
      sDaIn        : IN     std_ulogic;
      clock        : IN     std_ulogic;
      reset        : IN     std_ulogic;
      dataIn       : OUT    std_ulogic_vector (dataBitNb-2-1 DOWNTO 0);
      dataValid    : OUT    std_ulogic;
      sCl          : IN     std_ulogic;
      registerAddr : OUT    unsigned (dataBitNb-2-1 DOWNTO 0);
      writeData    : OUT    std_ulogic;
      sDaOut       : OUT    std_ulogic;
      dataOut      : IN     std_ulogic_vector (dataBitNb-2-1 DOWNTO 0);
      chipAddr     : OUT    unsigned (dataBitNb-3-1 DOWNTO 0);
      isSelected   : IN     std_ulogic
   );

-- Declarations

END i2cTransceiver ;





PACKAGE CommonLib IS

  function requiredBitNb (val : integer) return integer;

END CommonLib;




PACKAGE BODY CommonLib IS

  function requiredBitNb (val : integer) return integer is
    variable powerOfTwo, bitNb : integer;
  begin
    powerOfTwo := 1;
    bitNb := 0;
    while powerOfTwo <= val loop
      powerOfTwo := 2 * powerOfTwo;
      bitNb := bitNb + 1;
    end loop;
    return bitNb;
  end requiredBitNb;

END CommonLib;




-- library Common;
  use work.CommonLib.all;

architecture RTL of i2cTransceiver is
                                                                     -- receiver
  signal clDelayed      : std_uLogic;
  signal daDelayed      : std_uLogic;
  signal clRising       : std_uLogic;
  signal clFalling      : std_uLogic;
  signal daRising       : std_uLogic;
  signal daFalling      : std_uLogic;
  signal startCondition : std_uLogic;
  signal stopCondition  : std_uLogic;
  signal bitCounter     : unsigned(requiredBitNb(dataBitNb)-1 downto 0);
  signal inputShiftReg  : std_ulogic_vector(dataBitNb-2 downto 0);
  signal clRisingDelayed: std_uLogic;
  signal endOfWord      : std_uLogic;
  signal i2cByteValid   : std_uLogic;
  signal i2cByte        : std_ulogic_vector(dataIn'range);
                                                                          -- ack
  signal ackMoment      : std_uLogic;
  signal sendAck        : std_uLogic;
                                                                      -- decoder
  type   rxStateType    is (idle, readChipAddress, readRegAddress,
                            incAddress1, incAddress);
  signal rxState        : rxStateType;
  signal chipAddress    : unsigned(chipAddr'range);
  signal registerAddress: unsigned(registerAddr'range);
  signal writeMode      : std_uLogic;

  signal loadOutShiftReg: std_uLogic;
  signal enSdaOut       : std_uLogic;
  signal outputShiftReg : std_ulogic_vector(dataBitNb-2-1 downto 0);

begin
  --============================================================================
                                             -- start, stop and other conditions
  delayInputs: process(reset, clock)
  begin
    if reset = '1' then
      clDelayed <= '1';
      daDelayed <= '1';
      clRisingDelayed <= '0';
    elsif rising_edge(clock) then
      clDelayed <= sCl;
      daDelayed <= sDaIn;
      clRisingDelayed <= clRising;
    end if;
  end process delayInputs;

  clRising <= '1' when (sCl = '1') and (clDelayed = '0') else '0';
  clFalling <= '1' when (sCl = '0') and (clDelayed = '1') else '0';
  daRising <= '1' when (sDaIn = '1') and (daDelayed = '0') else '0';
  daFalling <= '1' when (sDaIn = '0') and (daDelayed = '1') else '0';
  startCondition <= '1' when (daFalling = '1') and (sCl = '1') else '0';
  stopCondition <= '1' when (daRising = '1') and (sCl = '1') else '0';

  ------------------------------------------------------------------------------
                                                                  -- bit counter
  countBitNb: process(reset, clock)
  begin
    if reset = '1' then
      bitCounter <= (others => '0');
    elsif rising_edge(clock) then
      if startCondition = '1' then
        bitCounter <= (others => '0');
      elsif stopCondition = '1' then
        bitCounter <= (others => '0');
      elsif clFalling = '1' then
        if bitCounter < dataBitNb-1 then
          bitCounter <= bitCounter + 1;
        else
          bitCounter <= to_unsigned(1, bitCounter'length);
        end if;
      end if;
    end if;
  end process countBitNb;

  endOfWord <= '1' when (clRisingDelayed = '1') and (bitCounter = dataBitNb-1)
    else '0';

  --============================================================================
                                                         -- input shift register
  shiftInputBits: process(reset, clock)
  begin
    if reset = '1' then
      inputShiftReg <= (others => '0');
    elsif rising_edge(clock) then
      if clRising = '1' then
        inputShiftReg(inputShiftReg'high downto 1) <= inputShiftReg(inputShiftReg'high-1 downto 0);
        inputShiftReg(0) <= sDaIn;
      end if;
    end if;
  end process shiftInputBits;

  ------------------------------------------------------------------------------
                                                -- read byte from shift register
  i2cByteValid <= '1' when (bitCounter = i2cByte'length) and (clFalling = '1')
    else '0';
  i2cByte <= inputShiftReg(i2cByte'range);

  storeByte: process(reset, clock)
  begin
    if reset = '1' then
      dataIn <= (others => '0');
    elsif rising_edge(clock) then
      if i2cByteValid = '1' then
        dataIn <= i2cByte;
      end if;
    end if;
  end process storeByte;

  --============================================================================
                                                           -- address extraction
  rxFsm: process(reset, clock)
  begin
    if reset = '1' then
      rxState <= idle;
    elsif rising_edge(clock) then
      if stopCondition = '1' then
        rxState <= idle;
      elsif startCondition = '1' then
        rxState <= readChipAddress;
      elsif endOfWord = '1' then
        case rxState is
          when readChipAddress =>
            if writeMode = '1' then
              rxState <= readRegAddress;
            else
              rxState <= incAddress1;
            end if;
          when readRegAddress =>
            rxState <= incAddress1;
          when incAddress1 =>
            rxState <= incAddress;
          when incAddress =>
            if (writeMode = '0') and (sDaIn = '1') then
              rxState <= idle;
            end if;
          when others => null;
        end case;
      end if;
    end if;
  end process rxFsm;

  dataValid <= endOfWord when (rxState = incAddress1) or (rxState = incAddress)
    else '0';

  ------------------------------------------------------------------------------
                                                  -- provide running i2c address
  updateAddress: process(reset, clock)
  begin
    if reset = '1' then
      chipAddress <= (others => '0');
      registerAddress <= (others => '0');
      writeMode <= '0';
    elsif rising_edge(clock) then
      if i2cByteValid = '1' then
        case rxState is
          when readChipAddress =>
            chipAddress <= resize(
              shift_right(unsigned(i2cByte), 1),
              chipAddress'length
            );
            if i2cByte(0) = '0' then -- i2cByte(0)=0 -> master write to slave
              writeMode <= '1';
            else
              writeMode <= '0';
              registerAddress <= registerAddress + 1;
            end if;
          when readRegAddress =>
            registerAddress <= resize(unsigned(i2cByte)-1, registerAddress'length);
          when incAddress1 | incAddress =>
            registerAddress <= registerAddress + 1;
          when others => null;
        end case;
      end if;
    end if;
  end process updateAddress;

  chipAddr <= chipAddress;
  registerAddr <= registerAddress;
  writeData <= writeMode;

  ------------------------------------------------------------------------------
                                                                  -- acknowledge
  findAckMoment: process(reset, clock)
  begin
    if reset = '1' then
      ackMoment <= '0';
      sendAck <= '0';
    elsif rising_edge(clock) then
      if (bitCounter = dataBitNb-2) and (clFalling = '1') then
        ackMoment <= '1';
      elsif clFalling = '1' then
        ackMoment <= '0';
      end if;
      if ackMoment = '0' then
        sendAck <= '0';
      elsif isSelected = '1' then
        if writeMode = '1' then
          sendAck <= '1';
        elsif rxState = readChipAddress then
          sendAck <= '1';
        end if;
      end if;
    end if;
  end process findAckMoment;

  --============================================================================
                                                              -- output controls
  controlAnswering: process(reset, clock)
  begin
    if reset = '1' then
      loadOutShiftReg <= '0';
      enSdaOut <= '0';
    elsif rising_edge(clock) then
      if endOfWord = '1' then
        loadOutShiftReg <= '1';
      elsif clRising = '1' then
        loadOutShiftReg <= '0';
      end if;
      if
        (bitCounter = 1) and
        ( (rxState = incAddress1) or (rxState = incAddress) ) and
        (writeMode = '0')
      then
        if sDaIn /= '0' then  -- let master finish ack pulse
          enSdaOut <= '1';
        end if;
      elsif ( (bitCounter = dataBitNb-2) and (clFalling = '1') ) or (rxState = idle) then
        enSdaOut <= '0';
      end if;
    end if;
  end process controlAnswering;

  ------------------------------------------------------------------------------
                                                        -- output shift register
  shiftOutputBits: process(reset, clock)
  begin
    if reset = '1' then
      outputShiftReg <= (others => '0');
    elsif rising_edge(clock) then
      if loadOutShiftReg = '1' then
        outputShiftReg <= (others => '1');
        outputShiftReg(dataOut'range) <= dataOut;
      elsif clFalling = '1' then
        outputShiftReg(outputShiftReg'high downto 1) <= outputShiftReg(outputShiftReg'high-1 downto 0);
        outputShiftReg(0) <= '0';
      end if;
    end if;
  end process shiftOutputBits;

  ------------------------------------------------------------------------------
                                                        -- reply to read request
  sDaOut <= '0' when sendAck = '1'
    else outputShiftReg(outputShiftReg'high) when enSdaOut = '1'
    else '1';

end RTL;




-- VHDL Entity gates.or2.symbol
--
-- Created:
--          by - cof.UNKNOWN (WE3479)
--          at - 10:55:52 23.08.2012
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2009.2 (Build 10)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
-- LIBRARY gates;
  use work.gates.all;

ENTITY or2 IS
  GENERIC( 
    delay : time := gateDelay
  );
  PORT( 
    in1  : IN     std_uLogic;
    in2  : IN     std_uLogic;
    out1 : OUT    std_uLogic
  );

-- Declarations

END or2 ;





ARCHITECTURE sim OF or2 IS
BEGIN
  out1 <= in1 or in2 after delay;
END ARCHITECTURE sim;





-- VHDL Entity StepperMotor.stepperMotorRegisters.symbol
--
-- Created:
--          by - guo.UNKNOWN (WEA20309)
--          at - 10:09:42 28.08.2014
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2009.2 (Build 10)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
  USE ieee.numeric_std.all;

ENTITY stepperMotorRegisters IS
   GENERIC( 
      busAddressBitNb        : positive := 8;
      busDataBitNb           : positive := 8;
      dividerBitNb           : positive := 8;
      angleBitNb             : positive := 8;
      hwOrientationBitNb     : positive := 3;
      baseAddress            : natural  := 0;
      orientationBaseAddress : natural  := 8
   );
   PORT( 
      clock            : IN     std_ulogic;
      reset            : IN     std_ulogic;
      busDataIn        : IN     std_ulogic_vector (busDataBitNb-1 DOWNTO 0);
      writeRegs        : IN     std_ulogic;
      target           : OUT    unsigned (angleBitNb-1 DOWNTO 0);
      busAddress       : IN     unsigned (busAddressBitNb-1 DOWNTO 0);
      divider          : OUT    unsigned (dividerBitNb-1 DOWNTO 0);
      en               : IN     std_ulogic;
      stepperEndBus    : OUT    std_ulogic;
      actual           : IN     unsigned (angleBitNb-1 DOWNTO 0);
      busDataOut       : OUT    std_ulogic_vector (busDataBitNb-1 DOWNTO 0);
      stepperEndSwitch : IN     std_ulogic;
      hwOrientation    : OUT    std_ulogic_vector (hwOrientationBitNb-1 DOWNTO 0);
      reached          : IN     std_ulogic;
      restart          : OUT    std_ulogic
   );

-- Declarations

END stepperMotorRegisters ;





ARCHITECTURE RTL OF stepperMotorRegisters IS

  constant dividerBaseAddr  : natural := baseAddress;
  constant angleBaseAddr    : natural := baseAddress + 2;
  constant stepperEndAddr   : natural := baseAddress + 4;
  constant statusAddr       : natural := baseAddress;
  constant statusEndSwitchId: natural := 0;
  constant statusReachedId  : natural := 1;
  constant hwStepperEndId   : natural := 3;
  constant hwRestartId      : natural := 4;
  constant registerLength   : positive := 2*busDataIn'length;
  signal   divider_int      : unsigned(registerLength-1 downto 0);
  signal   target_int       : unsigned(registerLength-1 downto 0);
  signal   actualReg        : unsigned(registerLength-1 downto 0);
  signal   switchAddress    : unsigned(busAddress'range);
  signal   enDelayed        : std_ulogic;
  signal   stepperEndMaster : std_ulogic;
  signal   stepperEndSlave  : std_ulogic;

BEGIN
  ------------------------------------------------------------------------------
                                                         -- store bytes from I2C
  storeBytes: process(reset, clock)
  begin
    if reset = '1' then
      divider_int <= (others => '0');
      target_int <= (others => '0');
      switchAddress <= to_unsigned(stepperEndAddr, switchAddress'length);
      hwOrientation <= (others => '0');
      stepperEndMaster <= '0';
      restart <= '0';
      stepperEndSlave <= '0';
    elsif rising_edge(clock) then
      if en = '1' then
                                                         -- controls from master
        if writeRegs = '1' then
          case to_integer(busAddress) is
            when dividerBaseAddr =>
              divider_int(busDataIn'range) <= unsigned(busDataIn);
            when dividerBaseAddr+1 =>
              divider_int(
                divider_int'high downto divider_int'length-busDataIn'length
              ) <= unsigned(busDataIn);
            when angleBaseAddr =>
              target_int(busDataIn'range) <= unsigned(busDataIn);
            when angleBaseAddr+1 =>
              target_int(
                target_int'high downto target_int'length-busDataIn'length
              ) <= unsigned(busDataIn);
            when stepperEndAddr =>
              switchAddress <= unsigned(busDataIn(switchAddress'range));
            when orientationBaseAddress =>
              hwOrientation <= busDataIn(hwOrientation'range);
              stepperEndMaster <= busDataIn(hwStepperEndId);
              restart <= busDataIn(hwRestartId);
            when others => null;
          end case;
                                                   -- controls from other slaves
                                                 -- !!! adresses are offset by 1
        else
          if busAddress = switchAddress+1 then
            stepperEndSlave <= not busDataIn(0);
          end if;
        end if;
      end if;
    end if;
  end process storeBytes;

  stepperEndBus <= stepperEndSlave or stepperEndMaster;

  ------------------------------------------------------------------------------
                                                -- update data after second byte
  storeControls: process(reset, clock)
  begin
    if reset = '1' then
      enDelayed <= '0';
      divider <= (others => '0');
      target <= (others => '0');
    elsif rising_edge(clock) then
      enDelayed <= en;
      if enDelayed = '1' then
        if busAddress(0) = '1' then
          divider <= resize(divider_int, divider'length);
          target <= resize(target_int, target'length);
        end if;
      end if;
    end if;
  end process storeControls;

  --============================================================================
                                                        -- store actual position
  storeValues: process(reset, clock)
  begin
    if reset = '1' then
      actualReg <= (others => '0');
    elsif rising_edge(clock) then
      if busAddress = angleBaseAddr-1 then
        actualReg <= resize(actual, actualReg'length);
      end if;
    end if;
  end process storeValues;

  ------------------------------------------------------------------------------
                                                        -- multiplex data to I2C
  sendStatus: process(busAddress, actualReg, stepperEndSwitch, reached)
  begin
    busdataOut <= (others => '1');
    case to_integer(busAddress) is
--when 0 => busdataOut <= X"55";
--when 31 => busdataOut <= std_ulogic_vector(to_unsigned(10, busdataOut'length));
      when angleBaseAddr =>
        busdataOut <= std_ulogic_vector(actualReg(busdataOut'range));
      when angleBaseAddr+1 =>
        busdataOut <= std_ulogic_vector(
          actualReg(actualReg'high downto actualReg'length-busdataOut'length)
        );
      when statusAddr =>
        busdataOut(statusEndSwitchId) <= not(stepperEndSwitch);
        busdataOut(statusReachedId) <= reached;
      when others => null;
    end case;
  end process sendStatus;

END ARCHITECTURE RTL;




--
-- VHDL Architecture StepperMotor.stepperMotorController.struct
--
-- Created:
--          by - guo.UNKNOWN (WEA20309)
--          at - 10:22:14 28.08.2014
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2009.2 (Build 10)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
  USE ieee.numeric_std.all;
-- LIBRARY gates;
  use work.gates.all;

-- LIBRARY gates;
-- LIBRARY I2C;
-- LIBRARY StepperMotor;

ARCHITECTURE struct OF stepperMotorController IS

   -- Architecture declarations
   constant dataBitNb: positive := i2cBitNb-2;
   constant addressBitNb: positive := dataBitNb;

   -- Internal signal declarations
   SIGNAL actualAngle   : unsigned(angleBitNb-1 DOWNTO 0);
   SIGNAL addr          : unsigned(addressBitNb-1 DOWNTO 0);
   SIGNAL chipAddr      : unsigned(dataBitNb-1-1 DOWNTO 0);
   SIGNAL clockDivider  : unsigned(dividerBitNb-1 DOWNTO 0);
   SIGNAL dataIn        : std_ulogic_vector(dataBitNb-1 DOWNTO 0);
   SIGNAL dataOut       : std_ulogic_vector(dataBitNb-1 DOWNTO 0);
   SIGNAL dataValid     : std_ulogic;
   SIGNAL hwOrientation : std_ulogic_vector(hwOrientationBitNb-1 DOWNTO 0);
   SIGNAL isSelected    : std_ulogic;
   SIGNAL reached       : std_ulogic;
   SIGNAL restart       : std_ulogic;
   SIGNAL stepEn        : std_ulogic;
   SIGNAL stepperEndBus : std_ulogic;
   SIGNAL stepperEndOr  : std_uLogic;
   SIGNAL targetAngle   : unsigned(angleBitNb-1 DOWNTO 0);
   SIGNAL writeRegs     : std_ulogic;


   -- Component Declarations
   COMPONENT or2
   GENERIC (
      delay : time := gateDelay
   );
   PORT (
      in1  : IN     std_uLogic ;
      in2  : IN     std_uLogic ;
      out1 : OUT    std_uLogic 
   );
   END COMPONENT;
   COMPONENT i2cTransceiver
   GENERIC (
      dataBitNb : positive := 10
   );
   PORT (
      sDaIn        : IN     std_ulogic ;
      clock        : IN     std_ulogic ;
      reset        : IN     std_ulogic ;
      dataIn       : OUT    std_ulogic_vector (dataBitNb-2-1 DOWNTO 0);
      dataValid    : OUT    std_ulogic ;
      sCl          : IN     std_ulogic ;
      registerAddr : OUT    unsigned (dataBitNb-2-1 DOWNTO 0);
      writeData    : OUT    std_ulogic ;
      sDaOut       : OUT    std_ulogic ;
      dataOut      : IN     std_ulogic_vector (dataBitNb-2-1 DOWNTO 0);
      chipAddr     : OUT    unsigned (dataBitNb-3-1 DOWNTO 0);
      isSelected   : IN     std_ulogic 
   );
   END COMPONENT;
   COMPONENT angleControl
   GENERIC (
      angleNbBits : positive := 8
   );
   PORT (
      clock      : IN     std_uLogic ;
      clockwise  : IN     std_uLogic ;
      enStep     : IN     std_uLogic ;
      reset      : IN     std_uLogic ;
      restart    : IN     std_ulogic ;
      sensorLeft : IN     std_uLogic ;
      stepperEnd : IN     std_uLogic ;
      target     : IN     unsigned (16-1 DOWNTO 0); -- (angleNbBits-1:0)
      actual     : OUT    unsigned (16-1 DOWNTO 0); -- (angleNbBits-1:0)
      coil1      : OUT    std_ulogic ;
      coil2      : OUT    std_uLogic ;
      coil3      : OUT    std_uLogic ;
      coil4      : OUT    std_uLogic ;
      reached    : OUT    std_ulogic 
   );
   END COMPONENT;
   COMPONENT stepperMotorDivider
   GENERIC (
      prescalerBitNb     : positive := 8;
      testPrescalerBitNb : positive := 10;
      dividerBitNb       : positive := 16
   );
   PORT (
      clock    : IN     std_ulogic ;
      reset    : IN     std_ulogic ;
      pwmEn    : OUT    std_ulogic ;
      divider  : IN     unsigned (dividerBitNb-1 DOWNTO 0);
      testMode : IN     std_ulogic 
   );
   END COMPONENT;
   COMPONENT stepperMotorRegisters
   GENERIC (
      busAddressBitNb        : positive := 8;
      busDataBitNb           : positive := 8;
      dividerBitNb           : positive := 8;
      angleBitNb             : positive := 8;
      hwOrientationBitNb     : positive := 3;
      baseAddress            : natural  := 0;
      orientationBaseAddress : natural  := 8
   );
   PORT (
      clock            : IN     std_ulogic ;
      reset            : IN     std_ulogic ;
      busDataIn        : IN     std_ulogic_vector (busDataBitNb-1 DOWNTO 0);
      writeRegs        : IN     std_ulogic ;
      target           : OUT    unsigned (angleBitNb-1 DOWNTO 0);
      busAddress       : IN     unsigned (busAddressBitNb-1 DOWNTO 0);
      divider          : OUT    unsigned (dividerBitNb-1 DOWNTO 0);
      en               : IN     std_ulogic ;
      stepperEndBus    : OUT    std_ulogic ;
      actual           : IN     unsigned (angleBitNb-1 DOWNTO 0);
      busDataOut       : OUT    std_ulogic_vector (busDataBitNb-1 DOWNTO 0);
      stepperEndSwitch : IN     std_ulogic ;
      hwOrientation    : OUT    std_ulogic_vector (hwOrientationBitNb-1 DOWNTO 0);
      reached          : IN     std_ulogic ;
      restart          : OUT    std_ulogic 
   );
   END COMPONENT;

   -- Optional embedded configurations
   -- pragma synthesis_off
--    FOR ALL : angleControl USE ENTITY StepperMotor.angleControl;
--    FOR ALL : i2cTransceiver USE ENTITY I2C.i2cTransceiver;
--    FOR ALL : or2 USE ENTITY gates.or2;
--    FOR ALL : stepperMotorDivider USE ENTITY StepperMotor.stepperMotorDivider;
--    FOR ALL : stepperMotorRegisters USE ENTITY StepperMotor.stepperMotorRegisters;
   -- pragma synthesis_on


BEGIN
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 1 eb1
   testOut <= (
     1 => stepperEndOr,
     2 => stepEn,
     3 => reached,
     4 => hwOrientation(1),
     5 => hwOrientation(2),
     6 => restart,
     7 => targetAngle(8),
     8 => targetAngle(7),
     9 => targetAngle(6),
     10=> actualAngle(8),
     11=> stepperEnd,
     12=> stepperEndBus,
     others => '0'
   );      
   

   -- HDL Embedded Text Block 3 eb3
   isSelected <='1' when chipAddr = kartBaseAddress/2 else '0';
   
   


   -- Instance port mappings.
   I_or : or2
      GENERIC MAP (
         delay => gateDelay
      )
      PORT MAP (
         in1  => stepperEndBus,
         in2  => stepperEnd,
         out1 => stepperEndOr
      );
   I_i2c : i2cTransceiver
      GENERIC MAP (
         dataBitNb => i2cBitNb
      )
      PORT MAP (
         sDaIn        => sDaIn,
         clock        => clock,
         reset        => reset,
         dataIn       => dataIn,
         dataValid    => dataValid,
         sCl          => sClIn,
         registerAddr => addr,
         writeData    => writeRegs,
         sDaOut       => sDaOut,
         dataOut      => dataOut,
         chipAddr     => chipAddr,
         isSelected   => isSelected
      );
   I_angle : angleControl
      GENERIC MAP (
         angleNbBits => angleBitNb
      )
      PORT MAP (
         clock      => clock,
         clockwise  => hwOrientation(1),
         enStep     => stepEn,
         reset      => reset,
         restart    => restart,
         sensorLeft => hwOrientation(2),
         stepperEnd => stepperEndOr,
         target     => targetAngle,
         actual     => actualAngle,
         coil1      => coil1,
         coil2      => coil2,
         coil3      => coil3,
         coil4      => coil4,
         reached    => reached
      );
   I_div : stepperMotorDivider
      GENERIC MAP (
         prescalerBitNb     => prescalerBitNb,
         testPrescalerBitNb => testPrescalerBitNb,
         dividerBitNb       => dividerBitNb
      )
      PORT MAP (
         clock    => clock,
         reset    => reset,
         pwmEn    => stepEn,
         divider  => clockDivider,
         testMode => testMode
      );
   I_regs : stepperMotorRegisters
      GENERIC MAP (
         busAddressBitNb        => addressBitNb,
         busDataBitNb           => dataBitNb,
         dividerBitNb           => dividerBitNb,
         angleBitNb             => angleBitNb,
         hwOrientationBitNb     => hwOrientationBitNb,
         baseAddress            => stepperBaseAddress,
         orientationBaseAddress => orientationBaseAddress
      )
      PORT MAP (
         clock            => clock,
         reset            => reset,
         busDataIn        => dataIn,
         writeRegs        => writeRegs,
         target           => targetAngle,
         busAddress       => addr,
         divider          => clockDivider,
         en               => dataValid,
         stepperEndBus    => stepperEndBus,
         actual           => actualAngle,
         busDataOut       => dataOut,
         stepperEndSwitch => stepperEnd,
         hwOrientation    => hwOrientation,
         reached          => reached,
         restart          => restart
      );

END struct;




-- VHDL Entity sequential.DFF.symbol
--
-- Created:
--          by - cof.UNKNOWN (WE3479)
--          at - 10:57:17 23.08.2012
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2009.2 (Build 10)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
-- LIBRARY gates;
  use work.gates.all;

ENTITY DFF IS
  GENERIC( 
    delay : time := 1 ns
  );
  PORT( 
    CLK : IN     std_uLogic;
    CLR : IN     std_uLogic;
    D   : IN     std_uLogic;
    Q   : OUT    std_uLogic
  );

-- Declarations

END DFF ;





ARCHITECTURE sim OF DFF IS
BEGIN

  process(clk, clr)
  begin
    if clr = '1' then
      q <= '0' after delay;
    elsif rising_edge(clk) then
      q <= d after delay;
    end if;
  end process;

END sim;




-- VHDL Entity gates.inverter.symbol
--
-- Created:
--          by - cof.UNKNOWN (WE3479)
--          at - 10:55:55 23.08.2012
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2009.2 (Build 10)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
-- LIBRARY gates;
  use work.gates.all;

ENTITY inverter IS
  GENERIC( 
    delay : time := 1 ns
  );
  PORT( 
    in1  : IN     std_uLogic;
    out1 : OUT    std_uLogic
  );

-- Declarations

END inverter ;





ARCHITECTURE sim OF inverter IS
BEGIN
  out1 <= NOT in1 after delay;
END sim;




-- VHDL Entity gates.logic1.symbol
--
-- Created:
--          by - cof.UNKNOWN (WE3479)
--          at - 10:55:54 23.08.2012
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2009.2 (Build 10)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
-- LIBRARY gates;
  use work.gates.all;

ENTITY logic1 IS
  PORT( 
    logic_1 : OUT    std_uLogic
  );

-- Declarations

END logic1 ;





ARCHITECTURE sim OF logic1 IS
BEGIN
  logic_1 <= '1';
END sim;




-- VHDL Entity gates.bufferUlogic.symbol
--
-- Created:
--          by - Everyone.Everyone (WEA20302)
--          at - 16:18:06 08/20/09
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2012.2 (Build 11)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
-- LIBRARY gates;
  use work.gates.all;

ENTITY bufferUlogic IS
   GENERIC( 
      delay : time := gateDelay
   );
   PORT( 
      in1  : IN     std_uLogic;
      out1 : OUT    std_uLogic
   );

-- Declarations

END bufferUlogic ;





ARCHITECTURE sim OF bufferUlogic IS
BEGIN
  out1 <= in1 after delay;
END ARCHITECTURE sim;





--
-- VHDL Architecture Board.FPGA_stepperMotorController.struct
--
-- Created:
--          by - guo.UNKNOWN (WEA20309)
--          at - 10:29:30 28.08.2014
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2009.2 (Build 10)
--
LIBRARY ieee;
   USE ieee.std_logic_1164.all;
   USE ieee.numeric_std.all;

-- LIBRARY gates;
   use work.gates.all;

-- LIBRARY gates;
-- LIBRARY sequential;
-- LIBRARY StepperMotor;

ARCHITECTURE struct OF FPGA_stepperMotorController IS

   -- Architecture declarations
   constant clockFrequency : real := 10.0E6;
   
   constant i2cBitNb : positive := 10;
   
   constant kartBaseAddress: positive := 16#26#; -- must be even
   constant stepperBaseAddress: natural := 4;
   constant testPrescalerBitNb: positive := 15;
   constant prescalerBitNb: positive := 8;
   constant dividerBitNb: positive := 16;
   constant angleBitNb: positive := 16;
   
   constant orientationBaseAddress: natural := 10;
   constant hwOrientationBitNb : positive := 3;
   constant testOutBitNb : positive := 12;

   -- Internal signal declarations
   SIGNAL Q               : std_uLogic_vector(1 TO 2);
   SIGNAL coil1           : std_ulogic;
   SIGNAL coil2           : std_ulogic;
   SIGNAL coil3           : std_ulogic;
   SIGNAL coil4           : std_ulogic;
   SIGNAL logic_1         : std_uLogic;
   SIGNAL reset           : std_uLogic;
   SIGNAL resetSynch      : std_ulogic;
   SIGNAL resetSynch_n    : std_ulogic;
   SIGNAL sClSynch        : std_uLogic;
   SIGNAL sDaIn           : std_uLogic;
   SIGNAL sDaInSynch      : std_uLogic;
   SIGNAL sDaOut          : std_uLogic;
   SIGNAL stepperEnd      : std_uLogic;
   SIGNAL stepperEndSynch : std_uLogic;
   SIGNAL testMode        : std_uLogic;
   SIGNAL testModeSynch   : std_uLogic;
   SIGNAL testOut         : std_ulogic_vector(1 TO testOutBitNb);


   -- Component Declarations
   COMPONENT bufferUlogic
   GENERIC (
      delay : time := gateDelay
   );
   PORT (
      in1  : IN     std_uLogic ;
      out1 : OUT    std_uLogic 
   );
   END COMPONENT;
   COMPONENT inverter
   GENERIC (
      delay : time := 1 ns
   );
   PORT (
      in1  : IN     std_uLogic ;
      out1 : OUT    std_uLogic 
   );
   END COMPONENT;
   COMPONENT logic1
   PORT (
      logic_1 : OUT    std_uLogic 
   );
   END COMPONENT;
   COMPONENT DFF
   GENERIC (
      delay : time := 1 ns
   );
   PORT (
      CLK : IN     std_uLogic ;
      CLR : IN     std_uLogic ;
      D   : IN     std_uLogic ;
      Q   : OUT    std_uLogic 
   );
   END COMPONENT;
   COMPONENT stepperMotorController
   GENERIC (
      i2cBitNb               : positive := 10;
      prescalerBitNb         : positive := 16;
      testPrescalerBitNb     : positive := 10;
      dividerBitNb           : positive := 8;
      angleBitNb             : positive := 4;
      hwOrientationBitNb     : positive := 3;
      kartBaseAddress        : positive := 16#26#;
      stepperBaseAddress     : natural  := 0;
      orientationBaseAddress : natural  := 8;
      testBitNb              : positive := 8
   );
   PORT (
      clock      : IN     std_ulogic ;
      reset      : IN     std_ulogic ;
      sClIn      : IN     std_uLogic ;
      sDaIn      : IN     std_uLogic ;
      stepperEnd : IN     std_ulogic ;
      testMode   : IN     std_ulogic ;
      coil1      : OUT    std_ulogic ;
      coil2      : OUT    std_ulogic ;
      coil3      : OUT    std_ulogic ;
      coil4      : OUT    std_ulogic ;
      sDaOut     : OUT    std_uLogic ;
      testOut    : OUT    std_ulogic_vector (1 TO testBitNb)
   );
   END COMPONENT;

   -- Optional embedded configurations
   -- pragma synthesis_off
--    FOR ALL : DFF USE ENTITY sequential.DFF;
--    FOR ALL : bufferUlogic USE ENTITY gates.bufferUlogic;
--    FOR ALL : inverter USE ENTITY gates.inverter;
--    FOR ALL : logic1 USE ENTITY gates.logic1;
--    FOR ALL : stepperMotorController USE ENTITY StepperMotor.stepperMotorController;
   -- pragma synthesis_on


BEGIN
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 2 eb2
   jtagIo(1) <= '0';
   jtagIo(2) <= '0';
   jtagIo(3) <= '0';
   

   -- HDL Embedded Text Block 3 eb3
   sDa <= '0' when sDaOut = '0'
     else 'Z';
   sDaIn <= sDa;
   

   -- HDL Embedded Text Block 4 eb4
   I_O(1 to 12) <= std_logic_vector(testOut);
   --I_O( 1) <= '0';
   --I_O( 2) <= '0';
   --I_O( 3) <= '0';
   --I_O( 4) <= '0';
   --I_O( 5) <= '0';
   --I_O( 6) <= '0';
   --I_O( 7) <= '0';
   --I_O( 8) <= '0';
   --I_O( 9) <= '0';
   --I_O(10) <= '0';
   --I_O(11) <= testOut(2);
   --I_O(12) <= '0';
   I_O(13) <= '0';         
   I_O(14) <= '1';         -- test mode
   I_O(15) <= '0';
   I_O(16) <= 'Z';         -- stepper end
   I_O(17) <= 'Z';         -- phase 2
   I_O(18) <= 'Z';         -- phase 4
   I_O(19) <= 'Z';         -- phase 3
   I_O(20) <= 'Z';         -- phase 1
   
   


   -- Instance port mappings.
   I4 : bufferUlogic
      GENERIC MAP (
         delay => gateDelay
      )
      PORT MAP (
         in1  => coil1,
         out1 => I_O(20)
      );
   I5 : bufferUlogic
      GENERIC MAP (
         delay => gateDelay
      )
      PORT MAP (
         in1  => coil2,
         out1 => I_O(17)
      );
   I6 : bufferUlogic
      GENERIC MAP (
         delay => gateDelay
      )
      PORT MAP (
         in1  => coil3,
         out1 => I_O(19)
      );
   I7 : bufferUlogic
      GENERIC MAP (
         delay => gateDelay
      )
      PORT MAP (
         in1  => coil4,
         out1 => I_O(18)
      );
   I19 : inverter
      GENERIC MAP (
         delay => 1 ns
      )
      PORT MAP (
         in1  => I_O(16),
         out1 => stepperEnd
      );
   I22 : inverter
      GENERIC MAP (
         delay => 1 ns
      )
      PORT MAP (
         in1  => I_O(14),
         out1 => testMode
      );
   I26 : inverter
      GENERIC MAP (
         delay => 1 ns
      )
      PORT MAP (
         in1  => resetSynch_n,
         out1 => resetSynch
      );
   I27 : inverter
      GENERIC MAP (
         delay => 1 ns
      )
      PORT MAP (
         in1  => reset_n,
         out1 => reset
      );
   I3 : logic1
      PORT MAP (
         logic_1 => logic_1
      );
   I18 : DFF
      GENERIC MAP (
         delay => 1 ns
      )
      PORT MAP (
         CLK => clock,
         CLR => resetSynch,
         D   => stepperEnd,
         Q   => stepperEndSynch
      );
   I20 : DFF
      GENERIC MAP (
         delay => 1 ns
      )
      PORT MAP (
         CLK => clock,
         CLR => resetSynch,
         D   => testMode,
         Q   => testModeSynch
      );
   I21 : DFF
      GENERIC MAP (
         delay => 1 ns
      )
      PORT MAP (
         CLK => clock,
         CLR => reset,
         D   => logic_1,
         Q   => resetSynch_n
      );
   I23 : DFF
      GENERIC MAP (
         delay => 1 ns
      )
      PORT MAP (
         CLK => clock,
         CLR => resetSynch,
         D   => sCl,
         Q   => sClSynch
      );
   I24 : DFF
      GENERIC MAP (
         delay => 1 ns
      )
      PORT MAP (
         CLK => clock,
         CLR => resetSynch,
         D   => sDaIn,
         Q   => sDaInSynch
      );
   I0 : stepperMotorController
      GENERIC MAP (
         i2cBitNb               => i2cBitNb,
         prescalerBitNb         => prescalerBitNb,
         testPrescalerBitNb     => testPrescalerBitNb,
         dividerBitNb           => dividerBitNb,
         angleBitNb             => angleBitNb,
         hwOrientationBitNb     => hwOrientationBitNb,
         kartBaseAddress        => kartBaseAddress,
         stepperBaseAddress     => stepperBaseAddress,
         orientationBaseAddress => orientationBaseAddress,
         testBitNb              => testOutBitNb
      )
      PORT MAP (
         clock      => clock,
         reset      => resetSynch,
         sClIn      => sClSynch,
         sDaIn      => sDaInSynch,
         stepperEnd => stepperEndSynch,
         testMode   => testModeSynch,
         coil1      => coil1,
         coil2      => coil2,
         coil3      => coil3,
         coil4      => coil4,
         sDaOut     => sDaOut,
         testOut    => testOut
      );

END struct;




